<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: contract/Contract.vue</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: contract/Contract.vue</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>&lt;template>
  &lt;div>
    &lt;div>
      &lt;!-- HEADER DE LA VISTA DEL CONTRATO -->
      &lt;div style="margin: 0 4rem" class="padding-top">
        &lt;el-header style="height: auto; margin: 0 2.75rem">
          &lt;el-row :gutter="15">
            &lt;!-- Filtros -->
            &lt;el-col :span="20" :offset="5">
              &lt;el-col :span="9">
                &lt;app-select
                  v-model="filterSelect"
                  :filterArray="allFilters"
                >&lt;/app-select>
              &lt;/el-col>
              &lt;el-col :span="11">
                &lt;!-- &lt;app-search-filter v-model="textSearch">&lt;/app-search-filter> -->
                &lt;el-input
                  class="input-head"
                  placeholder="Buscar"
                  prefix-icon="el-icon-search"
                  v-model="textSearch"
                  @clear="cleanSearch"
                  @keyup.native.enter="filterMaterials"
                  clearable
                >&lt;/el-input>
              &lt;/el-col>
              &lt;el-col :span="2">
                &lt;el-button
                  @click="filterMaterials"
                  type="primary"
                  :disabled="textSearch == ''"
                  >BUSCAR&lt;/el-button
                >
              &lt;/el-col>
            &lt;/el-col>
          &lt;/el-row>

          &lt;!-- Subtítulo -->
          &lt;el-col :span="24">
            &lt;div class="titleSection">Lista de Contratos&lt;/div>
          &lt;/el-col>

          &lt;!-- Botón nuevo -->
          &lt;div class="text-end" style="margin-top: 3rem">
            &lt;el-button @click="goGenerar()"  type="primary" plain
              >GENERAR ASIENTO &lt;br> &lt;span style="font-size: 11px">(DE AMORTIZACIÓN)&lt;/span>&lt;/el-button
            >
            &lt;el-button @click="goToNewContract('nuevoContrato')" type="primary"
              >&lt;p style="display: block; transform: translateY(8px);">NUEVO CONTRATO&lt;br> &lt;span style="visibility: hidden">(DE AMORTIZACIÓN)&lt;/span>&lt;p/>&lt;/el-button
            >
          &lt;/div>
        &lt;/el-header>
      &lt;/div>
    &lt;/div>
    &lt;!-- v-loading="loading" :element-loading-text="loadingText" -->
    &lt;div
      v-bind:class="[
        contracts.length == 0 ? 'remove-grid-container' : 'grid-container',
      ]"
      v-loading="loading"
      :element-loading-text="loadingText"
    >
      &lt;el-row
        v-bind:class="[
          contracts.length == 0 ? 'remove-grid-container' : 'grid-container',
        ]"
        v-if="contracts &amp;&amp; contracts.length !== 0"
      >
        &lt;el-col
          :style="{ border: contract.borderAddendum }"
          v-for="(contract, index) in contracts"
          :key="index"
          style="margin-bottom: 4rem"
        >
          &lt;el-card :body-style="{ padding: '0px' }" class="bg-gray">
            &lt;el-row :gutter="20">
              &lt;!-- Lado izquierdo -->
              &lt;el-col :span="8" class="bg-white">
                &lt;div
                  class="text-orange"
                  style="margin: 2rem 3rem"
                  v-if="contract.stateContrato !== 'CONTRATO ORIGINAL'"
                >
                  {{ contract.stateContrato }}
                &lt;/div>
                &lt;div style="margin: 3rem 3rem 3rem">
                  &lt;div class="title-styles" style="margin-bottom: 3rem">
                    {{ contract.contractName }}
                  &lt;/div>

                  &lt;div class="infoToShow__box">
                    &lt;div style="margin: 15px auto; font-size: 18px">
                      &lt;span class="infoToShow__title">
                        &lt;strong>Cod. Registro:&lt;/strong>
                      &lt;/span>
                      &lt;span style="color: #8f8f8f">{{
                        contract.contractCode
                      }}&lt;/span>
                    &lt;/div>
                    &lt;div style="margin: 15px auto; font-size: 18px">
                      &lt;span class="infoToShow__title">
                        &lt;strong>Cod. Proveedor:&lt;/strong>
                      &lt;/span>
                      &lt;span style="color: #8f8f8f">{{
                        contract.providerCode
                      }}&lt;/span>
                    &lt;/div>
                    &lt;div style="margin: 15px auto; font-size: 18px">
                      &lt;span class="infoToShow__title">
                        &lt;strong>Tipo de Proveedor:&lt;/strong>
                      &lt;/span>
                      &lt;span style="color: #8f8f8f">{{
                        contract.providerType
                      }}&lt;/span>
                    &lt;/div>

                    &lt;div style="margin: 15px auto; font-size: 18px">
                      &lt;span class="infoToShow__title">
                        &lt;strong>N° Contr. Distribuidor:&lt;/strong>
                      &lt;/span>
                      &lt;span style="color: #8f8f8f">{{
                        contract.contratoDistribuidor
                      }}&lt;/span>
                    &lt;/div>
                  &lt;/div>

                  &lt;div
                    v-if="contract.typeContract !== 'Afiliación'"
                    class="bg-orange-ligth font-general text-white subtitle-styles box-text1"
                    style="margin-bottom: 1rem; padding: 5px 10px; width: 100%"
                  >
                    Importe Total:
                    &lt;span class="text-white"
                      >{{ contract.currencySymbol }}
                      {{ contract.totalAmount }}&lt;/span
                    >
                  &lt;/div>
                  &lt;!-- vigencia -->
                  &lt;el-table
                    :data="contracts[index].validity"
                    size="medium"
                    style="margin-top: 3rem"
                    :header-cell-class-name="tableRowClassName"
                  >
                    &lt;el-table-column label="VIGENCIA">
                      &lt;el-table-column label="Inicio">
                        &lt;template slot-scope="scope">
                          &lt;div style="margin-left: 10px">
                            {{
                              new Date(
                                scope.row.startValidity
                              ).toLocaleDateString('en-GB')
                            }}
                          &lt;/div>
                        &lt;/template>
                      &lt;/el-table-column>
                      &lt;el-table-column label="Fin" prop="validityEnd">
                        &lt;template slot-scope="scope">
                          &lt;div style="margin-left: 10px">
                            &lt;p>
                              {{
                                new Date(
                                  scope.row.endValidity
                                ).toLocaleDateString('en-GB')
                              }}
                            &lt;/p>
                          &lt;/div>
                        &lt;/template>
                      &lt;/el-table-column>
                    &lt;/el-table-column>
                  &lt;/el-table>
                &lt;/div>
              &lt;/el-col>
              &lt;!-- Lado derecho  -->

              &lt;el-col :span="16">
                &lt;div style="margin: 1.5rem 3rem 1.5rem 2rem">
                  &lt;div class="text-end">
                    &lt;el-button
                      v-if="contract.canceledStatus"
                      class="border-grey-darken text-dark-gray-2"
                      plain
                      @click="confirmedContractView(contract, 'cancelado')"
                      >CANCELADO&lt;/el-button
                    >
                    &lt;el-button
                      v-if="contract.pendingStatus"
                      class="border-orange text-orange"
                      plain
                      @click="confirmedContractView(contract, 'pendiente')"
                      >PENDIENTE&lt;/el-button
                    >
                    &lt;el-button
                      v-if="
                        contract.confirmedStatus &amp;&amp;
                        contract.typeContract !== 'Afiliación'
                      "
                      class="border-red text-red"
                      plain
                      @click="changeToAmortizationViewcontract(contract)"
                      >AMORTIZACIÓN&lt;/el-button
                    >
                    &lt;el-button
                      v-if="contract.confirmedStatus"
                      class="border-green text-green"
                      plain
                      @click="confirmedContractView(contract, 'confirmado')"
                      >CONFIRMADO&lt;/el-button
                    >
                  &lt;/div>
                  &lt;h3>MATERIALES&lt;/h3>
                  &lt;p class="subtitle-styles" style="margin: 2rem 0">
                    N° de Materiales: {{ contract.refMaterials.length }}
                  &lt;/p>
                  &lt;div class="overflow-auto">
                    &lt;el-row
                      style="margin-bottom: 1rem"
                      v-for="(item, index) in contract.refMaterials"
                      :key="index"
                    >
                      &lt;!-- {{ item }} -->
                      &lt;el-col :span="2">
                        &lt;p
                          style="padding: 5px 0"
                          class="bg-dark-gray-2 text-white text-center"
                        >
                          {{ index + 1 }}
                        &lt;/p>
                      &lt;/el-col>
                      &lt;el-col :span="21" :offset="1" class="bg-white">
                        &lt;el-row>
                          &lt;!-- :span="(contract.typeContract !== 'Afiliación')?11:16" -->
                          &lt;el-col :span="11">
                            &lt;p style="padding: 5px 0.8rem">
                              {{ item.listTitle }}
                            &lt;/p>
                          &lt;/el-col>
                          &lt;el-col :span="7">
                            &lt;p class="bg-white text-material-type">
                              ({{ item.typeOfContent.substr(0, 3) }})
                            &lt;/p>
                          &lt;/el-col>
                          &lt;!-- v-if="contract.typeContract !== 'Afiliación'" -->
                          &lt;el-col :span="6">
                            &lt;p
                              style="padding: 5px 0.8rem"
                              class="text-orange"
                              :class="
                                Object(item.numChapters).length > 0
                                  ? 'fw-500'
                                  : ''
                              "
                            >
                              &lt;span v-if="item.unitPrice !== 'Cortesía'">{{
                                item.currencySymbol
                              }}&lt;/span>
                              {{ item.unitPrice }}
                            &lt;/p>
                          &lt;/el-col>
                        &lt;/el-row>
                        &lt;!-- &amp;&amp; contract.typeContract !== 'Afiliación' -->
                        &lt;el-row
                          v-if="Object(item.numChapters).length > 0"
                          class="bg-white"
                        >
                          &lt;el-row
                            v-for="(tem, index) in item.numChapters"
                            :key="index"
                          >
                            &lt;el-col :span="11">
                              &lt;el-row>
                                &lt;el-col :span="12">
                                  &lt;p style="padding: 5px 0.8rem" class="f-15">
                                    &lt;span class="fw-500">Temp.:&lt;/span>
                                    {{ tem.season }}
                                  &lt;/p>
                                &lt;/el-col>
                                &lt;el-col :span="12">
                                  &lt;p style="padding: 5px 0.8rem" class="f-15">
                                    &lt;span class="fw-500">N° de Cap.:&lt;/span>
                                    {{ tem.chapters }}
                                  &lt;/p>
                                &lt;/el-col>
                              &lt;/el-row>
                            &lt;/el-col>
                            &lt;el-col :span="7">
                              &lt;p
                                style="padding: 5px 0.8rem; text-align: right"
                                class="f-15"
                              >
                                Precio por Capítulo:
                              &lt;/p>
                            &lt;/el-col>
                            &lt;el-col :span="6">
                              &lt;!-- {{tem}} -->
                              &lt;p
                                style="padding: 5px 0.8rem"
                                class="text-orange f-15"
                              >
                                &lt;span v-if="tem.chapterPrice !== 'Cortesía'">{{
                                  item.currencySymbol
                                }}&lt;/span>
                                {{ tem.chapterPrice }}
                              &lt;/p>
                            &lt;/el-col>
                            &lt;hr
                              style="border: 0.5px solid #eceaea"
                              v-if="
                                Object.keys(item.numChapters).length - 1 > index
                              "
                            />
                          &lt;/el-row>
                        &lt;/el-row>
                      &lt;/el-col>
                    &lt;/el-row>
                  &lt;/div>
                  &lt;p
                    v-if="contract.typeContract !== 'Afiliación'"
                    class="text-end"
                    style="margin: 2rem 3rem 0 0"
                  >
                    &lt;strong>
                      Total Materiales:
                      &lt;span
                        style="margin-left: 2rem"
                        v-if="contract.totalAmount !== ''"
                        >{{ contract.currencySymbol }}
                        {{ contract.totalMaterials }}&lt;/span
                      >
                      &lt;span
                        style="margin-left: 2rem"
                        v-if="contract.totalAmount == ''"
                        >No ingresado&lt;/span
                      >
                    &lt;/strong>
                  &lt;/p>
                  &lt;p
                    class="text-end igvText"
                    v-if="contract.providerType == 'Local'"
                  >
                    IGV: 18% ({{ contract.currencySymbol }}
                    {{ contract.percentage }})
                  &lt;/p>
                &lt;/div>
              &lt;/el-col>
            &lt;/el-row>
          &lt;/el-card>
        &lt;/el-col>
      &lt;/el-row>
      &lt;!-- Tarjeta 'No hay resultado' -->
      &lt;el-row
        v-bind:class="[
          contracts.length == 0 ? 'remove-grid-container' : 'grid-container',
        ]"
        v-if="isShowNoResults"
      >
        &lt;el-col :span="20" :offset="2">
          &lt;el-card :body-style="{ padding: '0px' }" class="bg-gray">
            &lt;el-col :span="8" style="margin-top: 1rem" class="text-center">
              &lt;img src="@/assets/images/detective.svg" alt />
            &lt;/el-col>
            &lt;el-col :span="16">
              &lt;div style="margin-top: 5rem">
                &lt;p class="title-styles">¡Lo sentimos!&lt;/p>
                &lt;p class="title-styles">
                  No encontramos resultados para tu búsqueda
                &lt;/p>
              &lt;/div>
            &lt;/el-col>
          &lt;/el-card>
        &lt;/el-col>
      &lt;/el-row>
    &lt;/div>
  &lt;/div>
&lt;/template>
&lt;script>
import { modifyText } from '@/utils/modifyText.js'
import SearchFilter from '@/components/searchFilter.vue'
import Select from '@/components/AppSelect.vue'
import { mapState } from 'vuex'
import { HTTP } from '@/main.js'
  /**
  * @vue-data {Array} allFilters - Lista de los filtros para las busquedas de un contrato
  * @vue-computed {Array} contracts - Lista de los contratos filtrados por tipo de usuario
  */
export default {
  components: {
    'app-search-filter': SearchFilter,
    'app-select': Select,
  },
  data() {
    return {
      filterSelect: '', //select
      textSearch: '', //buscador
      allFilters: [
        { value: 'contractCode', label: 'Código Registro' },
        { value: 'providerCode', label: 'Código Proveedor' },
        { value: 'codMaterial', label: 'Código Material' },
        { value: 'startValidity', label: 'Vigencia - Inicio' },
        { value: 'endValidity', label: 'Vigencia - Fin' },
      ],
      code: '', // para generar código de contrato
      loading: true,
      isShowNoResults: false,
      IsClick: false,
      allContracts: [],
    }
  },
  computed: {
    ...mapState({
      loadingText: (state) => state.textLoadingContracts,
    }),
    contracts() {
      return !this.IsClick ? this.allContracts : this.searchContracts
    },
    importTotal() {
      return this.contract.totalAmount !== ''
        ? 'No ingresado'
        : this.contract.currencySymbol + ' ' + this.contract.totalAmount
    },
  },
  created() {
    this.getContract()
  },
  methods: {
    goGenerar() {
      this.$router.push('asiento')
    },
    /** Trae la lista e todos los contratos*/
    getContract() {
      this.loading = true
      HTTP.get('contracts').then((res) => {
        this.allContracts = res.data.contracts
        this.loading = !this.allContracts.length > 0
      })
    },
    /** Filtra los contratos dependiendo de la referencia enviada */
    filterMaterials() {
      let cadenaConexion

      if (
        this.filterSelect == 'startValidity' ||
        (this.filterSelect == 'endValidity' &amp;&amp; this.textSearch !== '')
      ) {
        var myDate = this.textSearch
        myDate = myDate.split('/')
        var newDate = myDate[1] + '/' + myDate[0] + '/' + myDate[2]
        var timestamp = new Date(newDate).getTime()
        cadenaConexion = HTTP.get(
          `contracts/typeOfFilter/${this.filterSelect}/word/${timestamp}`
        )
      } else if (this.filterSelect == '' &amp;&amp; this.textSearch !== '') {
        cadenaConexion = HTTP.get(
          `contracts/typeOfFilter/contractName/word/${this.textSearch}`
        )
      } else {
        cadenaConexion = HTTP.get(
          `contracts/typeOfFilter/${this.filterSelect}/word/${this.textSearch}`
        )
      }
      cadenaConexion.then((res) => {
        this.isShowNoResults = res.data.contracts.length == 0 ? true : false
        // this.$store.dispatch('SELECTED_PROGRAMS', res.data.contracts)
        this.searchContracts = res.data.contracts
        this.IsClick = true
      })
    },
    /** Borra los datos escritos en el friltro */
    cleanSearch() {
      this.filterSelect = ''
      this.isShowNoResults = false
      this.IsClick = false
    },
    //bóton de nuevo contrato
    goToNewContract(nuevo) {
      this.$store.dispatch('setItemInConfirmedContract', nuevo)
      // this.$localStorage.set('stateAdendum', JSON.stringify(nuevo))
      this.$router.push({ name: 'newContract' })
    },
    tableRowClassName({ row, rowIndex }) {
      if (rowIndex === 0) {
        return 'first-row-header'
      }
      if (rowIndex === 1) {
        return 'second-row-header'
      }
    },
    /** Trae los datos de las amortizaciones y esquemas de los materiales del contrato y envia a la vista de amortizacion
    * @param {Object} contract - Objeto con los datos del contrato
    */
    async changeToAmortizationViewcontract(contract) {
      const { data } = await HTTP.get(
        `amortization/ofContract/${contract.geminisCode}`
      )

      this.$localStorage.set('contractAmort', JSON.stringify(data))
      this.$localStorage.set('amortContract', JSON.stringify(contract))

      this.$router.push({ name: 'amortizationContract' })
    },
    /** Trae los datos del contrato al que se quiere ingresar y se entra a la vista con los datos del contrato
    * @param {Object} contract - Objeto que trae todos los datos del contrato
    * @param {String} estado - Estado del contrato, si es pendiente, confirmado o anulado
    */
    confirmedContractView(contract, estado) {
      console.log(contract)
      this.$store.dispatch('setContract', contract)
      this.$store.dispatch('setContractOriginal', contract)
      this.$store.dispatch('setContractStatus', estado)
      this.$router.push({ name: 'confirmedContract' })
    },
    verifyContent() {
      if (this.$store.state.contracts.length > 0) {
        this.loading = false
      } else {
        this.loading =
          this.$store.state.contracts.length == 0 &amp;&amp; this.textSearch !== ''
            ? false
            : true
      }
    },
  },
  beforeDestroy() {
    this.$store.commit('updateTexContracts', 'Cargando Contratos...')
  },
}
&lt;/script>


&lt;style scoped>
.titleSection {
  background: #4a4a4a;
  color: white;
  padding: 10px 10px 10px 35px;
  text-transform: uppercase;
  font-weight: 400;
  margin: 40px auto;
  font-size: 18px;
}
.text-material-type {
  padding: 5px 0.8rem;
  color: #828282;
  text-transform: uppercase;
  text-align: right;
}
.f-15 {
  font-size: 15px;
}
.fw-500 {
  font-weight: 500;
}

.igvText {
  margin: 0.5rem 3rem 0 0;
  color: #828282;
  font-weight: 500;
}
&lt;/style></code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-ConfirmedContract.html">ConfirmedContract</a></li><li><a href="module-Contract.html">Contract</a></li><li><a href="module-Cut.html">Cut</a></li><li><a href="module-HistoryContract.html">HistoryContract</a></li><li><a href="module-Material.html">Material</a></li><li><a href="module-Material2.html">Material2</a></li><li><a href="module-NewContract.html">NewContract</a></li><li><a href="module-NewMaterial.html">NewMaterial</a></li><li><a href="module-NewMaterial2.html">NewMaterial2</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Wed Aug 11 2021 17:08:52 GMT-0500 (GMT-05:00)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
